<?php
/*******************************************************************
 *			
 * 			Fichier			:	class.sessions.php 
 * 			Cr le			:	05 mars 2003 
 * 			Dernire modif	:	06 mai 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


if( !defined('CLASS_SESSIONS_INC') )
{

define('CLASS_SESSIONS_INC', true); 

class Session {
	
	var $user_ip	 = ''; 
	var $sessid_url	 = ''; 
	var $session_id  = ''; 
	var $sessiondata = array(); 
	var $cfg_cookie  = array(); 
	
	var $new_session  = FALSE; 
	var $is_logged_in = FALSE; 
	
	function session()
	{
		global $nl_config, $_SERVER, $_ENV; 
		
		//
		// Rcupration de l'IP 
		//
		$client_ip = ( !empty($_SERVER['REMOTE_ADDR']) ) ? $_SERVER['REMOTE_ADDR'] : ( ( !empty($_ENV['REMOTE_ADDR']) ) ? $_ENV['REMOTE_ADDR'] : '127.0.0.1' );
		
		if( preg_match('/^(\d+\.\d+\.\d+\.\d+)/', getenv('HTTP_X_FORWARDED_FOR'), $match) )
		{
			$private_ip = trim($match[1]); 
			
			/*
			 * Liens utiles sur les diffrentes plages d'ip : 
			 * 
			 * @link http://www.commentcamarche.net/internet/ip.php3 
			 * @link http://www.usenet-fr.net/fur/comp/reseaux/masques.html 
			 */  
			
			//
			// Liste d'ip non valides 
			//
			$pattern_ip = array(); 
			$pattern_ip[] = '/^0\..*/'; // Rseau 0 n'existe pas 
			$pattern_ip[] = '/^127\.0\.0\.1/'; // ip locale 
			
			// Plages d'ip spcifiques  l'intranet 
			$pattern_ip[] = '/^10\..*/'; 
			$pattern_ip[] = '/^172\.1[6-9]\..*/'; 
			$pattern_ip[] = '/^172\.2[0-9]\..*/'; 
			$pattern_ip[] = '/^172\.3[0-1]\..*/'; 
			$pattern_ip[] = '/^192\.168\..*/'; 
			
			// Plage d'adresse de classe D rserve pour les flux multicast et de classe E, non utilise 
			$pattern_ip[] = '/^22[4-9]\..*/'; 
			$pattern_ip[] = '/^2[3-5][0-9]\..*/'; 
			
			$client_ip = preg_replace($pattern_ip, $client_ip, $private_ip); 
		}
		
		$this->user_ip = $this->encode_ip($client_ip); 
		
		preg_match('/^http(s)?:\/\/(.*?)\/?$/i', $nl_config['urlsite'], $match); 
		
		$this->cfg_cookie['cookie_name'] = $nl_config['cookie_name']; 
		$this->cfg_cookie['cookie_path'] = $nl_config['cookie_path']; 
		//$this->cfg_cookie['cookie_domain'] = $match[2]; 
		$this->cfg_cookie['cookie_domain'] = ''; 
		$this->cfg_cookie['cookie_secure'] = ( !empty($match[1]) ) ? 1 : 0; 
	}
	
	function open($admindata, $autologin)
	{
		global $db; 
		
		$current_time = time(); 
		$liste = ( !empty($this->sessiondata['listeid']) ) ? $this->sessiondata['listeid'] : 0; 
		
		if( !empty($admindata['session_id']) )
		{
			$this->session_id = $admindata['session_id']; 
		}
		
		$sql = "UPDATE " . SESSIONS_TABLE . " 
				SET admin_id = " . $admindata['admin_id'] . ", session_start = $current_time, 
					session_time = $current_time, session_ip = '" . $this->user_ip . "', session_liste = $liste 
				WHERE session_id = '" . $this->session_id . "'"; 
		if( $this->session_id == '' || !$db->query($sql) )
		{
			$this->new_session = TRUE; 
			$this->session_id  = generate_key(); 
			
			$sql = "INSERT INTO " . SESSIONS_TABLE . " (session_id, admin_id, session_start, session_time, session_ip, session_liste) 
				VALUES('" . $this->session_id . "', " . $admindata['admin_id'] . ", $current_time, $current_time, '" . $this->user_ip . "', $liste)"; 
			if( !$db->query($sql) )
			{
				trigger_error('Impossible de dmarrer une nouvelle session', CRITICAL_ERROR); 
			}
			
			$admindata['session_id'] = $this->session_id; 
		}
		
		$admindata['session_start']	= $current_time; 
		$admindata['session_time']	= $current_time; 
		$admindata['session_ip']	= $this->user_ip; 
		$admindata['session_liste']	= $liste; 
		
		$sessiondata = array(
			'adminloginkey' => ( $autologin ) ? $admindata['admin_pwd'] : '',
			'adminid' => $admindata['admin_id']
		); 
		
		$this->send_cookie('sessid', $this->session_id, 0); 
		$this->send_cookie('data', serialize($sessiondata), $current_time + 31536000); 
		
		$this->sessid_url	= 'sessid=' . $this->session_id; 
		$this->is_logged_in = TRUE; 
		
		return $admindata; 
	}
	
	function check($liste = 0)
	{
		global $db, $nl_config, $_GET, $_COOKIE; 
		
		if( !empty($_COOKIE[$this->cfg_cookie['cookie_name'] . '_sessid']) || !empty($_COOKIE[$this->cfg_cookie['cookie_name'] . '_data']) )
		{
			$this->session_id = ( !empty($_COOKIE[$this->cfg_cookie['cookie_name'] . '_sessid']) ) ? $_COOKIE[$this->cfg_cookie['cookie_name'] . '_sessid'] : ''; 
			$sessiondata   	  = ( !empty($_COOKIE[$this->cfg_cookie['cookie_name'] . '_data']) ) ? unserialize(stripslashes($_COOKIE[$this->cfg_cookie['cookie_name'] . '_data'])) : ''; 
		}
		else
		{
			$this->session_id = ( !empty($_GET['sessid']) ) ? $_GET['sessid'] : ''; 
			$sessiondata   	  = ''; 
			
			if( $this->session_id != '' )
			{
				$this->sessid_url = 'sessid=' . $this->session_id; 
			}
		}
		
		$current_time = time(); 
		$this->sessiondata = ( is_array($sessiondata) ) ? $sessiondata : array(); 
		
		if( $this->session_id != '' )
		{
			//
			// Rcupration des infos sur la session et l'utilisateur 
			//
			$sql = "SELECT a.*, s.* 
					FROM " . ADMIN_TABLE . " AS a, " . SESSIONS_TABLE . " AS s 
					WHERE s.session_id = '" . $this->session_id . "' 
					  AND a.admin_id = s.admin_id";	
			if( !($result = $db->query($sql)) )
			{
				trigger_error('Impossible de rcuprer les infos sur la session et l\'utilisateur', CRITICAL_ERROR); 
			}
			
			if( $row = $db->fetch_array($result) )
			{
				//
				// Comparaison des ip pour viter la substitution des sessions 
				// Peut poser problme avec certains proxy 
				//
				$len_check_ip = 4; 
				
				if( substr($row['session_ip'], 0, $len_check_ip) == substr($this->user_ip, 0, $len_check_ip) )
				{
					$force_update = false; 
					if( ( $liste > 0 || $liste == -1 ) && $liste != $row['session_liste'] )
					{
						$force_update = true; 
						$row['session_liste'] = ( $liste == -1 ) ? 0 : $liste; 
					}
					
					if( ($current_time - $row['session_time']) > 60 || $force_update )
					{
						$sql = "UPDATE " . SESSIONS_TABLE . " 
								SET session_time = $current_time, session_liste = " . $row['session_liste'] . " 
								WHERE session_id = '" . $this->session_id . "'"; 
						if( !$db->query($sql) )
						{
							trigger_error('Impossible de mettre  jour la session en cours', CRITICAL_ERROR); 
						}
						
						if( $force_update )
						{
							$this->send_cookie('listeid', $row['session_liste'], $current_time + 31536000); 
						}
					}
					
					//
					// Suppression des sessions primes 
					//
					if( !($current_time % 5) )
					{
						$expiry_time = $current_time - $nl_config['session_length']; 
						
						$sql = "DELETE FROM " . SESSIONS_TABLE . " 
							WHERE session_time < $expiry_time AND session_id <> '" . $this->session_id . "'"; 
						if( !$db->query($sql) )
						{
							trigger_error('Impossible de supprimer les sessions primes', CRITICAL_ERROR); 
						}
					}
					
					$this->is_logged_in = TRUE; 
					
					return $row; 
				}
			}
		}
		
		$this->sessiondata['listeid'] = ( !empty($_COOKIE[$this->cfg_cookie['cookie_name'] . '_listeid']) ) ? intval($_COOKIE[$this->cfg_cookie['cookie_name'] . '_listeid']) : 0; 
		
		//
		// Connexion automatique 
		//
		if( !empty($this->sessiondata['adminloginkey']) )
		{
			$admin_id = ( !empty($this->sessiondata['adminid']) ) ? intval($this->sessiondata['adminid']) : 0; 
			
			return $this->login($admin_id, $this->sessiondata['adminloginkey'], TRUE); 
		}
		
		$this->send_cookie('sessid', '', $current_time - 31536000); 
		$this->send_cookie('data', '', $current_time - 31536000); 
		
		return false; 
	}
	
	function logout($admin_id)
	{
		global $db; 
		
		$current_time = time(); 
		
		if( $this->session_id != '' )
		{
			$sql = "DELETE FROM " . SESSIONS_TABLE . " 
				WHERE session_id = '" . $this->session_id . "' AND admin_id = " . $admin_id; 
			if( !$db->query($sql) )
			{
				trigger_error('Erreur lors de la fermeture de la session', CRITICAL_ERROR); 
			}
		}
		
		$this->send_cookie('sessid', '', $current_time - 31536000); 
		$this->send_cookie('data', '', $current_time - 31536000); 
	}
	
	function login($admin_mixed, $admin_pwd, $autologin)
	{
		global $db; 
		
		$sql = 'SELECT a.*, s.session_id, s.session_start, s.session_time, s.session_ip, s.session_liste 
				FROM ' . ADMIN_TABLE . ' AS a 
				LEFT JOIN ' . SESSIONS_TABLE . ' AS s ON a.admin_id = s.admin_id WHERE '; 
		$sql .= ( is_numeric($admin_mixed) ) ? 'a.admin_id = ' . $admin_mixed : 'LOWER(a.admin_login) = \'' . strtolower($admin_mixed) . '\''; 
		$sql .= ' ORDER BY s.session_time DESC'; 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir les donnes sur cet utilisateur', ERROR); 
		}
		
		if( $admindata = $db->fetch_array($result) )
		{
			$db->free_result($result); 
			
			if( $admindata['admin_pwd'] == $admin_pwd )
			{
				return $this->open($admindata, $autologin); 
			}
		}
		
		return false; 
	}
	
	function send_cookie($name, $cookie_data, $cookie_time)
	{
		setcookie(
			$this->cfg_cookie['cookie_name'] . '_' . $name,
			$cookie_data,
			$cookie_time,
			$this->cfg_cookie['cookie_path'],
			$this->cfg_cookie['cookie_domain'],
			$this->cfg_cookie['cookie_secure']
		); 
	}
	
	//
	// Import de phpBB et modifi 
	// Encodage et dcodage des IP pour stockage et comparaisons plus simples 
	//
	function encode_ip($dotquad_ip)
	{
		$ip_sep = explode('.', $dotquad_ip);
		return sprintf('%02x%02x%02x%02x', $ip_sep[0], $ip_sep[1], $ip_sep[2], $ip_sep[3]);
	}
	
	function decode_ip($hex_ip)
	{
		$hexip_parts = explode('.', chunk_split($hex_ip, 2, '.')); 
		array_pop($hexip_parts); 
		
		return implode('.', array_map('hexdec', $hexip_parts)); 
	}
}

//
// Ajout de l'identifiant de session s'il est transmis par l'url
//
function sessid($var, $is_str = false)
{
	global $session; 
	
	if( $session->sessid_url != '' )
	{
		if( $is_str )
		{
			$var = preg_replace('/(action|a href)="(?!ftp|http|mailto|javascript|{)([^"]+)"/e', '\'\\1="\' . sessid(\'\\2\') . \'"\'', $var); 
		}
		else if( !preg_match('/sessid=[[:alnum:]]+/', $var) )
		{
			$var .= ( ( strpos($var, '?') ) ? '&amp;' : '?' ) . $session->sessid_url; 
		}
	}
	
	return $var; 
}

}
?>